//<c>   Copyright 1990-2000 by Gerry J. Danen; all rights reserved.

//<t>   Gas consumption calculator

#include "gd_tools.h"
#include <iostream.h>


char    *dfuel( int metric, int which )
{
    static  char *met[] = { "litres", "litre", "Litres", "Litre" } ;
    static  char *old[] = { "gallons", "gallon", "Gallons", "Gallon" } ;

    if ( metric )
        return( met[which-1] );
    else
        return( old[which-1] );
}


char    *ddist( int metric, int which )
{
    static  char *met[] = { "kilometres", "kilometre" } ;
    static  char *old[] = { "miles", "mile" } ;

    if ( metric )
        return( met[which-1] );
    else
        return( old[which-1] );
}


double  fuel_efficiency( int metric, int which )
{
    static  double met[] = {  8.0, 12.0 } ;
    static  double old[] = { 20.0, 25.0 } ;

    if ( metric )
        return( met[which-1] );
    else
        return( old[which-1] );
}


void main()
{
    char        measure = ' ';
    double      start, end, fuel_qty, distance, consumption;

    printf( "\nGas Consumption Calculator\n\nMetric or Dumb old measurement system (M/D)? " );
    while ( measure != 'M' && measure != 'D' )
    {
        measure = _getch();
        measure = toupper(measure);
    }
    int metric ;
    if ( measure == 'M' )
        metric = TRUE ;
    else
        metric = FALSE ;
    cout << measure << "\n\nStarting odometer reading: ";
    cin  >> start;
    cout << "  Ending odometer reading: ";
    cin  >> end;
    if ( start > end )
    {
        cout << "Odometer readings are reversed.  I'll switch them for you!\n";
        double tq = start ;
        start = end ;
        end = tq ;
    }
    cout << '\n' << dfuel(metric,3) << " purchased: ";
    cin  >> fuel_qty;

    distance = 1 + (end - start);
    consumption = distance / fuel_qty;

    cout << "\n   Distance = " << distance << " " << ddist(metric,1) << ", odometer from " << start << " to " << end << ".\n";
    cout << "Consumption = " << consumption << " " << ddist(metric,1) << " per " << dfuel(metric,2) << ".\n\n";

    cout << "Your vehicle's fuel use is ";
    if ( consumption < fuel_efficiency(metric,1) )
        cout << "poor.\n";
    else if ( (consumption >= fuel_efficiency(metric,1)) && (consumption < fuel_efficiency(metric,2)) )
        cout << "good.\n";
    else
        cout << "excellent.\n";
}
